
public class ThreadModel extends Model implements Runnable {

    Thread thread;
    volatile boolean computing = false;
    volatile boolean stop = false;
    final Object end;

    public ThreadModel() {
        end = new Object();
    }

    @Override
    public synchronized void compute() {
        if (computing == false) {
            computing = true;
            thread = new Thread(this);
            thread.start();
            System.out.println("ThreadModel start computation thread " + thread.getId());

        }
    }
    
    public synchronized boolean isRunning() {
        return thread.isAlive();
    }
    
    public synchronized void stopComputation() {
        if (thread != null) {
            System.out.println("Stopping the thread " + thread.getId());
            synchronized (end) {
                stop = true;
            }
            try {
                System.out.println("stopComputation: join");
                thread.join();
                System.out.println("stopComputation: join");
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
            System.out.println("Thread " + thread.getId() + " stopped");
            thread = null;
        }
    }

    @Override
    public void run() {
        restartComputation();
        boolean finished = false;
        while (!computePart() && !finished) {
            System.out.println("run check end");
            synchronized (end) {
                finished = stop;
                //   }
                System.out.println("Run: " + finished);

            }
        }
        System.out.println("Run: Synchronized this");
        synchronized (end) {
            computing = false;
        }
    }
}
